require "OysterDb/version"

#This module will contain classes that support the visualization system for the db
module OysterDb

    #Models a single oyster
    class Oyster
        #This will produce read methods for all the oyster properties
        attr_reader :id, :grade, :volume, :length, :width, :height
        #Will create a new oyster object given a hash with all the data
        #Paramaters should include Grade, Volume, Width, Length, Height, Id
        def initialize(data_hash)
            @id = data_hash["id"]
            if data_hash["Grade"]
                @grade = data_hash["Grade"]
            else
                @grade = "No grade recorded"
            end
            if data_hash["Volume"]
                @volume = data_hash["Volume"]
            else
                @volume = "No volume recorded"
            end
            if data_hash["Length"]
                @length = data_hash["Length"]
            else
                @length = "No length recoreded"
            end
            if data_hash["Width"]
                @width = data_hash["Width"]
            else
                @width = "No width recorded"
            end
            if data_hash["Height"]
                @height = data_hash["Height"]
            else
                @height = "No height recorded"
            end
        end


    end

    #This will model a table containing oyster data for the day
    class Table
        attr_writer :oysters
        attr_reader :oysters, :date
        #This will create a new table given the date
        #Will create an empty array to hold oyster objects
        def initialize(date)
            @date = date
            @oysters = []
        end

        #Returns total number of oysters in table
        def get_count
            return @oysters.count
        end

        #Allows an oyster to be added to the table
        def add_oyster(oyster)
            @oysters.push(oyster)
        end

    end

    #Use this class to parse through the date on the timestamp
    class Date
        attr_reader :day, :timestamp
        #This will initialize a new date with the given timestamp
        def initialize(timestamp)
            day_and_time = timestamp.split('_')
            @day = day_and_time[0]
            @time = day_and_time[1]
        end

        #Produces a string version of this object
        def to_s
            return "#{@day} at #{@time}"
        end

	#Returns the full timestamp
	def timestamp
		return "#{@day}_#{@time}"
	end
    end
end
